package cz.cuni.amis.pogamut.ut2004.lectures.hsbot;

import java.util.logging.Level;

import cz.cuni.amis.pogamut.base.utils.guice.AgentScoped;
import cz.cuni.amis.pogamut.base.utils.math.DistanceUtils;
import cz.cuni.amis.pogamut.base3d.worldview.object.ILocated;
import cz.cuni.amis.pogamut.base3d.worldview.object.Location;
import cz.cuni.amis.pogamut.ut2004.agent.module.sensor.visibility.model.VisibilityLocation;
import cz.cuni.amis.pogamut.ut2004.bot.impl.UT2004Bot;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbcommands.Initialize;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbcommands.Move;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbcommands.Rotate;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbcommands.SendMessage;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.*;
import cz.cuni.amis.pogamut.ut2004.hideandseek.bot.UT2004BotHSController;
import cz.cuni.amis.pogamut.ut2004.hideandseek.protocol.HSBotState;
import cz.cuni.amis.pogamut.ut2004.hideandseek.protocol.HSScoreChangeReason;
import cz.cuni.amis.pogamut.ut2004.hideandseek.protocol.messages.HSAssignSeeker;
import cz.cuni.amis.pogamut.ut2004.hideandseek.protocol.messages.HSBotStateChanged;
import cz.cuni.amis.pogamut.ut2004.hideandseek.protocol.messages.HSPlayerScoreChanged;
import cz.cuni.amis.pogamut.ut2004.hideandseek.protocol.messages.HSRoundEnd;
import cz.cuni.amis.pogamut.ut2004.hideandseek.protocol.messages.HSRoundStart;
import cz.cuni.amis.pogamut.ut2004.hideandseek.protocol.messages.HSRoundState;
import cz.cuni.amis.pogamut.ut2004.hideandseek.protocol.messages.HSRunnerCaptured;
import cz.cuni.amis.pogamut.ut2004.hideandseek.protocol.messages.HSRunnerFouled;
import cz.cuni.amis.pogamut.ut2004.hideandseek.protocol.messages.HSRunnerSafe;
import cz.cuni.amis.pogamut.ut2004.hideandseek.protocol.messages.HSRunnerSpotted;
import cz.cuni.amis.pogamut.ut2004.hideandseek.protocol.messages.HSRunnerSurvived;
import cz.cuni.amis.pogamut.ut2004.utils.UT2004BotRunner;
import cz.cuni.amis.utils.Cooldown;
import cz.cuni.amis.utils.Heatup;
import cz.cuni.amis.utils.Tuple2;
import cz.cuni.amis.utils.collections.MyCollections;
import cz.cuni.amis.utils.exception.PogamutException;
import java.util.*;
import java.util.concurrent.TimeUnit;

/**
 * HideAndSeek bot torso
 *
 * @author Jimmy
 */
@AgentScoped
public class HideAndSeekBot extends UT2004BotHSController<UT2004Bot> {

    /**
     * Just for the numbering of bots.
     */
    private static int number = 0;
    //boolean runToSafeArea = false;
    //private boolean atFirstLocation = false;
    private NavPoint loc = null;
    private List<NavPoint> locs = new ArrayList<NavPoint>();
    private boolean suicideRunner = true;
    private boolean finding = true;
    private boolean runHome = false;
    private boolean camper = true;
    private Random rnd = new Random();
    private Cooldown suincideCooldown = new Cooldown(10, TimeUnit.SECONDS);
    private Cooldown rotateHeater = new Cooldown(1200);
    private boolean capture = false;
    private boolean rotate = false;

    private <T extends ILocated> ILocated[] toILocatededArray(Collection<T> col) {
        ILocated[] result = new ILocated[col.size()];

        int i = 0;
        for (Iterator<T> it = col.iterator(); it.hasNext();) {
            result[i] = (ILocated) it.next();
            ++i;
        }

        return result;
    }

//    private List<NavPoint> getDistanceMapSorted(Collection<NavPoint> locations, NavPoint target) {
//        if (locations == null) {
//            return null;
//        }
//        if (target == null) {
//            return null;
//        }
//        if (target.getLocation() == null) {
//            return null;
//        }
//
//        List<Tuple2<NavPoint, Double>> distances = new ArrayList<Tuple2<NavPoint, Double>>(locations.size());
//
//        for (NavPoint location : locations) {
//            double distance = fwMap.getDistance(location, target);//getDistance.getDistance(location, target);
//            distances.add(new Tuple2<NavPoint, Double>(location, distance));
//        }
//
//        Collections.sort((List) distances, new Comparator<Tuple2<NavPoint, Double>>() {
//
//            @Override
//            public int compare(Tuple2<NavPoint, Double> o1, Tuple2<NavPoint, Double> o2) {
//                double result = o1.getSecond() - o2.getSecond();
//                if (result < 0) {
//                    return -1;
//                }
//                if (result > 0) {
//                    return 1;
//                }
//                return 0;
//            }
//        });
//
//        List<NavPoint> result = new ArrayList<NavPoint>(distances.size());
//
//        for (Tuple2<NavPoint, Double> location : distances) {
//            result.add(location.getFirst());
//        }
//
//        return result;
//    }
    @Override
    public Initialize getInitializeCommand() {
        // TODO: substitute "Put_Your_Name_Here" with your full name, e.g. "Jakub_Gemrot"
        return new Initialize().setName("Petr_Fanta" + (++number));
    }

    @SuppressWarnings("unchecked")
    @Override
    public void botInitialized(GameInfo gameInfo, ConfigChange config, InitedMessage init) {
        navigation.getLog().setLevel(Level.WARNING);
    }

    @Override
    public void botFirstSpawn(GameInfo gameInfo, ConfigChange config, InitedMessage init, Self self) {
        // change to ALL to receive logs from the navigation so you can get a grasp on how it is working
        pathExecutor.getLog().setLevel(Level.WARNING);
    }

    // --------------------
    // ====================
    // HIDE AND SEEK EVENTS
    // ====================
    // --------------------
    /**
     * Some RUNNER has just survived the round. <p><p> This event is triggered
     * at the end of the round for every RUNNER that has not been FOULED,
     * CAPTURED and did not make it to SAFE area.
     *
     * @param event
     */
    @Override
    protected void hsRunnerSurvived(HSRunnerSurvived event, boolean me) {
    }

    /**
     * Some RUNNER has just been spotted by the SEEKER.
     *
     * @param event
     */
    @Override
    protected void hsRunnerSpotted(HSRunnerSpotted event, boolean me) {
        //runToSafeArea = true;
    }

    /**
     * Some RUNNER has just made it to the safe-area.
     *
     * @param event
     */
    @Override
    protected void hsRunnerSafe(HSRunnerSafe event, boolean me) {
    }

    /**
     * Some RUNNER has just been fouled-out because it stepped into the
     * restricted-area while it was activated.
     *
     * @param event
     * @param me whether this event speaks about your bot
     */
    @Override
    protected void hsRunnerFouled(HSRunnerFouled event, boolean me) {
    }

    /**
     * Some RUNNER has just been captured by the SEEKER, i.e., seeker has
     * spotted the runner and made it to the safe-area before the runner.
     *
     * @param event
     * @param me whether this event speaks about your bot
     */
    @Override
    protected void hsRunnerCaptured(HSRunnerCaptured event, boolean me) {
    }

    /**
     * Round state update has been received.
     *
     * @param event
     */
    @Override
    protected void hsRoundState(HSRoundState event) {
        //event.
    }

    /**
     * New round has just started, you may use this event to initialize your
     * data-structures.
     *
     * @param event
     */
    @Override
    protected void hsRoundStart(HSRoundStart event) {
        navigation.stopNavigation(); // prevent commands from previous round to be still effective
        loc = null;
        locs = new ArrayList<NavPoint>();
        suicideRunner = true;
        finding = true;
        runHome = false;
        capture = false;
        camper = rnd.nextDouble() < 0.4;
        suicideRunner = rnd.nextDouble() < 0.5;
        suincideCooldown = new Cooldown(rnd.nextInt(45000));
        rotateHeater = new Cooldown(1200);
        rotate = false;

    }

    /**
     * Round has just ended, you may use this event to cleanup your
     * data-structures.
     *
     * @param event
     */
    @Override
    protected void hsRoundEnd(HSRoundEnd event) {
    }

    /**
     * Some player (runner/seeker) score has just changed, you may examine the
     * reason within {@link HSPlayerScoreChanged#getScoreChangeReason()}, see
     * {@link HSScoreChangeReason}.
     *
     * @param event
     * @param me whether this event speaks about your bot
     */
    @Override
    protected void hsPlayerScoreChanged(HSPlayerScoreChanged event, boolean me) {
    }

    /**
     * Some bot {@link HSBotState} has been updated.
     *
     * @param event
     * @param me whether this event speaks about your bot
     */
    @Override
    protected void hsBotStateChanged(HSBotStateChanged event, boolean me) {
        //event.
    }

    /**
     * SEEKER role has been just assigned to some bot.
     *
     * @param event
     * @param me whether this event speaks about your bot
     */
    @Override
    protected void hsAssignSeeker(HSAssignSeeker event, boolean me) {
    }

    // -----
    // =====
    // LOGIC
    // =====
    // -----
    @Override
    public void beforeFirstLogic() {
    }

    @Override
    public void logic() {
        // mark that another logic iteration has began
        log.info("====== LOGIC ITERATION ======");

        // UNCOMMENT TO GET DETAIL INFO DURING RUN-TIME
        // logState();

        if (!hide.isRoundRunning()) {
            // Game or Game-Round is not running yet...
            return;
        }

        if (!hide.isMeAlive()) {
            // I'm not alive ~ already captured / escaped
            return;
        }

        switch (hide.getMyState()) {
            case RUNNER:
                logicRunner();
                break;
            case RUNNER_SPOTTED:
                logicRunnerSpotted();
                break;
            case SEEKER:
                logicSeeker();
                break;
            default:
                // SHOULD NOT REACH HERE, BUT LET'S PLAY SAFE...
                return;
        }
    }

    private void logState() {
        log.info("------      STATE      ------");
        log.info("Game state:                  " + hide.getGameState());
        log.info("Game running:                " + hide.isGameRunning());
        if (!hide.isGameRunning()) {
            return;
        }
        log.info("Round running:               " + hide.isRoundRunning());
        if (!hide.isRoundRunning()) {
            return;
        }
        log.info("Me:                          " + hide.getMyState());
        log.info("Me spawned?                  " + hide.isMeAlive());
        log.info("Hiding time left:            " + hide.getRemainingHidingTime());
        log.info("Restricted area time left:   " + hide.getRemainingRestrictedAreaTime());
        log.info("Round time left:             " + hide.getRemainingRoundTime());
        log.info("Distance to safe-area:       " + hide.getMySafeAreaDistance());
        log.info("Distance to restricted-area: " + hide.getMyRestrictedAreaDistance());
    }

    // ------------
    // ============
    // LOGIC RUNNER
    // ============
    // ------------
    private void logicRunner() {
        log.info("------ RUNNER ------");
        // YOU ARE RUNNER => one who should be hiding

        if (suicideRunner) {
            if (hide.isHidingTime() || hide.isRestrictedAreaActivated()) {
                log.info("HIDING TIME");
                // SEEKER has not been spawned yet, you have time to hide out!    

                //schovani
                if (loc == null) { //!navigation.isNavigating() ||
                    Set<NavPoint> locations = visibility.getCoverNavPointsFrom(hide.getSafeArea());
                    //List<NavPoint> locations1 = getDistanceMapSorted(locations, navPoints.getNearestVisibleNavPoint());
                    //DistanceUtils.getDistanceSorted(locations, info.getLocation());
                    //int rndInt = rnd.nextInt(Math.min(locations1.size(), 5));
                    //loc = locations1.get(rndInt);//visibility.getNearestCoverNavPointFrom(hide.getSafeArea());
                    loc = MyCollections.getRandom(locations);
                    navigation.navigate(loc);
                }

                act.act(new Rotate().setAmount(60 * 65535 / 360));
                //navigation.getPathExecutor().setFocus(hide.getSafeArea());

                //bot.getAct().act(new Rotate().setAmount(60 * 65535 / 360));
                //act.act(new Move().setFocusLocation(hide.getSafeArea()));

//                Player enemy = players.getNearestVisiblePlayer();
//                if ((enemy != null) && (enemy.getId() == hide.getSeekerId()) && !hide.isRestrictedAreaActivated()) {
//                    runToSafeArea();
//                }

                for (Player enemy : players.getVisiblePlayers().values()) {
                    if (hide.getBotState(enemy.getId()) == HSBotState.SEEKER) {
                        if (!hide.isRestrictedAreaActivated() && !hide.isHidingTime()) {
                            runToSafeArea();
                        }
                    }
                }

                return;
            }

//        if (hide.isRestrictedAreaActivated()) {
//            log.info("RESTRICTED AREA ACTIVE");
//            // SEEKER has been spawned into the environment but you cannot save yourself yet
//            //         "easy-win" by standing in the safe are at the beginning of the game is not allowed 
//            return;
//        }
            if (suincideCooldown.isCool() && !hide.isRestrictedAreaActivated() && !hide.isHidingTime()) {
                runToSafeArea();
            }

            // SEEKER is present in the game, but restricted area is not active, 
            // you can save yourself by running to safe area before the SEEKER spots you and returns first
        } else {
            if (loc == null) {
                Set<NavPoint> locations = visibility.getCoverNavPointsFrom(hide.getSafeArea());
//                List<NavPoint> locations1 = DistanceUtils.getDistanceSorted(locations, info.getLocation());
                int rndInt = rnd.nextInt(Math.min(locations.size(), 5));
                loc = DistanceUtils.getNthFarthest(rndInt, locations, hide.getSafeArea()); //locations1.get(locations1.size() - rndInt - 1);
                navigation.navigate(loc);
            }

            act.act(new Rotate().setAmount(60 * 65535 / 360));
            for (Player enemy : players.getVisiblePlayers().values()) {
                if (hide.getBotState(enemy.getId()) == HSBotState.SEEKER) {
                    if (!hide.isRestrictedAreaActivated() && !hide.isHidingTime()) {
                        runToSafeArea();
                    }
                }
            }
        }
    }

    // --------------------
    // ====================
    // LOGIC RUNNER SPOTTED
    // ====================
    // --------------------
    private void logicRunnerSpotted() {
        log.info("------ RUNNER SPOTTED ------");
        // YOU ARE RUNNER who has already been spotted by the SEEKER
        // if SEEKER gets to the safe point first, it will catch you

        runToSafeArea();
    }

    // ------------
    // ============
    // LOGIC SEEKER
    // ============
    // ------------
    private void logicSeeker() {
        log.info("------ SEEKER ------");
        // you are SEEKER, one who should be finding other runners and catching them

        if (camper) {
            Player enemy = players.getNearestVisiblePlayer();
            if (enemy != null) {
                move.turnTo(enemy);
            } else {
                move.turnHorizontal(60);
            }
        } else {

            if (runHome && capture && !navigation.isNavigating()) {
                runHome = false;
                finding = true;
                navigation.stopNavigation();
                capture = false;
                //act.act(new SendMessage().setGlobal(true).setText("REstart find!"));
            }

            if (!capture) {
                if (hide.canCaptureRunner() && !capture && !(hide.getSafeAreaDistance(info.getLocation()) < 30)) {
                    runToSafeArea();
                    capture = true;
                    //act.act(new SendMessage().setGlobal(true).setText("Capture!"));
                } else {
                    boolean seeEnemy = false;
                    Player enemy = null;
                    for (Player player : players.getVisiblePlayers().values()) {
                        if (hide.getBotState(player.getId()) == HSBotState.RUNNER) {
                            seeEnemy = true;
                            enemy = player;
                        }
                    }

                    if (seeEnemy && enemy != null) {
                        move.turnTo(enemy);
                        navigation.stopNavigation();
                    } else {
                        if (finding) {
                            if (locs.isEmpty()) {
                                locs = DistanceUtils.getDistanceSorted(visibility.getCoverNavPointsFrom(hide.getSafeArea()), hide.getSafeArea());
                                //locs = DistanceUtils.getDistanceSorted(navPoints.getNavPoints().values(), hide.getSafeArea());
//                                for (int i = 0; i < 5; ++i) {
//                                    if (!locs.isEmpty()) {
//                                        locs.remove(0);
//                                    }
//                                }

                                if (locs.isEmpty()) {
                                    return;
                                }
                            }

                            if (!navigation.isNavigating() && loc == null) {
                                loc = locs.get(0);
                                locs.remove(0);
                                navigation.navigate(loc);
                            } else if ((!navigation.isNavigating() && loc != null)
                                    || ((loc != null) && visibility.isVisible(loc) && !visibility.isVisible(loc, hide.getSafeArea()))) {
                                navigation.stopNavigation();
                                move.turnTo(loc);
//                                if (!rotate) {
//                                    act.act(new SendMessage().setGlobal(true).setText("Rotate?"));
//                                    rotate = true;
//                                    rotateHeater.heat();
//                                } else {
//                                    move.turnHorizontal(60);
//                                    if (rotateHeater.isHot()) {
                                        rotate = false;
                                        finding = false;
                                        loc = null;
                                    //}
                                //}
                            }

                        } else {
                            if (!(hide.getSafeAreaDistance(info.getLocation()) < 30)) {
                                runToSafeArea();
                            } else {
                                navigation.stopNavigation();
                                if (!rotate) {
                                    //act.act(new SendMessage().setGlobal(true).setText("Rotate?"));
                                    rotate = true;
                                    rotateHeater.use();
                                } else {
                                    move.turnHorizontal(60);
                                    if (rotateHeater.isCool()) {
                                        rotate = false;
                                        finding = true;
                                        runHome = false;
                                    }
//                                    else {
//                                        act.act(new SendMessage().setGlobal(true).setText("Rotate?"));
//                                    }
                                }

                            }
                        }
                    }
                }

            }


//            if (hide.canCaptureRunner()) {
//                log.info("CAN CAPTURE RUNNER!");
//
//                runToSafeArea();
//            } else {
//
//                if (finding) {
//                    if (locs.isEmpty()) {
//                        locs = DistanceUtils.getDistanceSorted(visibility.getCoverNavPointsFrom(hide.getSafeArea()), hide.getSafeArea());
//                        if (locs.isEmpty()) {
//                            return;
//                        }
//                    }
//                    if (!navigation.isNavigating() && loc == null) {
//                        loc = locs.get(0);
//                        locs.remove(0);
//                        navigation.navigate(loc);
//                    } else if ((!navigation.isNavigating() && loc != null) || ((loc != null) && (visibility.isVisible(loc)))) {
//                        finding = false;
//                        loc = null;
//                    }
//                } else {
//                    if (info.getLocation().getDistance(hide.getSafeArea()) > 50) {
//                        runToSafeArea();
//                    } else {
//                        finding = true;
//                        runHome = false;
//                    }
//
//                }
//
//            }
        }
    }

    private void runToSafeArea() {
        if (!navigation.isNavigating() || runHome == false) {
            navigation.navigate(hide.getSafeArea());
            runHome = true;
        }

        if (hide.getSafeAreaDistance(info.getLocation()) > 200 && hide.getSafeAreaDistance(info.getLocation()) <= 400 && visibility.isVisible(hide.getSafeArea())) {
            move.dodgeTo(hide.getSafeArea(), false);
        } else if (hide.getSafeAreaDistance(info.getLocation()) > 400 && hide.getSafeAreaDistance(info.getLocation()) <= 600 && visibility.isVisible(hide.getSafeArea())) {
            move.dodgeTo(hide.getSafeArea(), true);
        }
    }

    @Override
    public void botKilled(BotKilled event) {
        navigation.stopNavigation();
    }

    public static void main(String args[]) throws PogamutException {
        // LEAVE THIS BE!
        // Start the debug game via HideAndSeekGame !!!
        new UT2004BotRunner(HideAndSeekBot.class, "HSBot").setMain(true).setLogLevel(Level.WARNING).startAgents(1);
    }
}
